## libgit2 1.8.2~rc1+ds2

=== CMakeLists.txt ===
# libgit2: the cross-platform, linkable library implementation of git.
# See `README.md` for build instructions.
#
# This top-level CMakeLists.txt sets up configuration options and
# determines which subprojects to build.

cmake_minimum_required(VERSION 3.5.1)

project(libgit2 VERSION "1.8.2" LANGUAGES C)

# Add find modules to the path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")

#
# Build options
#

# Experimental features
option(EXPERIMENTAL_SHA256     "Enable experimental SHA256 support (for R&D/testing)"  OFF)

# Optional subsystems
option(BUILD_SHARED_LIBS       "Build Shared Library (OFF for Static)"                  ON)
option(BUILD_TESTS             "Build Tests using the Clar suite"                       ON)
option(BUILD_CLI               "Build the command-line interface"                       ON)
option(BUILD_EXAMPLES          "Build library usage example apps"                      OFF)
option(BUILD_FUZZERS           "Build the fuzz targets"                                OFF)

# Suggested functionality that may not be available on a per-platform basis
option(USE_THREADS             "Use threads for parallel processing when possible"      ON)
option(USE_NSEC                "Support nanosecond precision file mtimes and ctimes"    ON)

# Backend selection
option(USE_SSH                 "Enable SSH support. Can be set to a specific backend" OFF)
option(USE_HTTPS               "Enable HTTPS support. Can be set to a specific backend" ON)
option(USE_SHA1                "Enable SHA1. Can be set to CollisionDetection(ON)/HTTPS" ON)
option(USE_SHA256              "Enable SHA256. Can be set to HTTPS/Builtin" ON)
option(USE_GSSAPI              "Link with libgssapi for SPNEGO auth"      OFF)
   set(USE_HTTP_PARSER         "" CACHE STRING "Specifies the HTTP Parser implementation; either system or builtin.")
#  set(USE_XDIFF               "" CACHE STRING "Specifies the xdiff implementation; either system or builtin.")
   set(REGEX_BACKEND           "" CACHE STRING "Regular expression implementation. One of regcomp_l, pcre2, pcre, regcomp, or builtin.")
option(USE_BUNDLED_ZLIB        "Use the bundled version of zlib. Can be set to one of Bundled(ON)/Chromium. The Chromium option requires a x86_64 processor with SSE4.2 and CLMUL" OFF)

# Debugging options
option(USE_LEAK_CHECKER        "Run tests with leak checker"                           OFF)
option(USE_STANDALONE_FUZZERS  "Enable standalone fuzzers (compatible with gcc)"       OFF)
option(DEBUG_POOL              "Enable debug pool allocator"                           OFF)
option(DEBUG_STRICT_ALLOC      "Enable strict allocator behavior"                      OFF)
option(DEBUG_STRICT_OPEN       "Enable path validation in open"                        OFF)

# Output options
option(SONAME                  "Set the (SO)VERSION of the target"                      ON)
   set(LIBGIT2_FILENAME        "git2" CACHE STRING "Name of the produced binary")
option(DEPRECATE_HARD          "Do not include deprecated functions in the library"    OFF)

# Compilation options
option(ENABLE_WERROR           "Enable compilation with -Werror"                       OFF)

if(UNIX)
	# NTLM client requires crypto libraries from the system HTTPS stack
	if(NOT USE_HTTPS)
		option(USE_NTLMCLIENT  "Enable NTLM support on Unix."                  OFF)
	else()
		option(USE_NTLMCLIENT  "Enable NTLM support on Unix."                   ON)
	endif()

	option(ENABLE_REPRODUCIBLE_BUILDS "Enable reproducible builds"                 OFF)
endif()

if(APPLE)
	option(USE_ICONV           "Link with and use iconv library"                    ON)
endif()

if(MSVC)
	# This option must match the settings used in your program, in particular if you
	# are linking statically
	option(STATIC_CRT          "Link the static CRT libraries"                      ON)

	# If you want to embed a copy of libssh2 into libgit2, pass a
	# path to libssh2
	option(EMBED_SSH_PATH      "Path to libssh2 to embed (Windows)"                OFF)

	# Enable leak checking using the debugging C runtime.
	option(WIN32_LEAKCHECK     "Enable leak reporting via crtdbg"                  OFF)
endif()

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()


# Modules

include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(CheckPrototypeDefinitionSafe)
include(AddCFlagIfSupported)
include(FindPkgLibraries)
include(FindThreads)
include(FindStatNsec)
include(Findfutimens)
include(GNUInstallDirs)
include(IdeSplitSources)
include(FeatureSummary)
include(EnableWarnings)
include(DefaultCFlags)
include(ExperimentalFeatures)


#
# Subdirectories
#

add_subdirectory(src)

if(BUILD_TESTS)
	enable_testing()
	add_subdirectory(tests)
endif()

if(BUILD_EXAMPLES)
	add_subdirectory(examples)
endif()

if(BUILD_FUZZERS)
	if((BUILD_TESTS OR BUILD_EXAMPLES) AND NOT USE_STANDALONE_FUZZERS)
		message(FATAL_ERROR "Cannot build the fuzzer and the tests or examples together")
	endif()
	add_subdirectory(fuzzers)
endif()


# Export for people who use us as a dependency

if(NOT "${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
	set(LIBGIT2_DEPENDENCY_OBJECTS ${LIBGIT2_DEPENDENCY_OBJECTS} PARENT_SCOPE)
	set(LIBGIT2_SYSTEM_LIBS ${LIBGIT2_SYSTEM_LIBS} PARENT_SCOPE)
endif()


# Summary

feature_summary(WHAT ENABLED_FEATURES DESCRIPTION "Enabled features:")
feature_summary(WHAT DISABLED_FEATURES DESCRIPTION "Disabled features:")

=== debian/changelog ===
libgit2 (1.8.2~rc1+ds2-1ubuntu2) plucky; urgency=medium

  * Keep vendored llhttp on i386 too

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 22:16:59 +0100

libgit2 (1.8.2~rc1+ds2-1ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Use OpenSSL as the crypto backend
    - Use cmake:native in d/tests/control
    - Lower optimization level to O2 on ppc64el to fix a test failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 Oct 2024 22:08:02 +0100

libgit2 (1.8.2~rc1+ds2-1) unstable; urgency=medium

  * Keep vendored llhttp for ports architectures
  * New upstream version 1.8.2~rc1+ds2
  * Update d/copyright
  * Use vendored llhttp on architectures without nodejs (Closes: #1084223)

 -- Timo Röhling <roehling@debian.org>  Tue, 08 Oct 2024 22:45:48 +0200

libgit2 (1.8.2~rc1+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sat, 05 Oct 2024 01:02:23 +0200

libgit2 (1.8.2~rc1+ds-1) experimental; urgency=medium

  * New upstream version 1.8.2~rc1+ds
    - Revert premature const correctness change to
      git_commit_create() and git_commit_create_buffer()

 -- Timo Röhling <roehling@debian.org>  Sun, 15 Sep 2024 09:52:48 +0200

libgit2 (1.8.1+ds-2) experimental; urgency=medium

  * Fix version ordering for -rc releases in d/watch
  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.0
  * Move back to http-parser from llhttp (Closes: #1081534)

 -- Timo Röhling <roehling@debian.org>  Thu, 12 Sep 2024 16:04:48 +0200

libgit2 (1.8.1+ds-1) experimental; urgency=medium

  * Update Files-Excluded for newly vendored HTTP parser
  * New upstream version 1.8.1+ds
  * Update patches
    - Drop handle-bashim.patch (merged upstream)
  * Bump SONAME to 1.8
  * Migrate from http-parser to llhttp

 -- Timo Röhling <roehling@debian.org>  Mon, 20 May 2024 11:21:07 +0200

=== debian/control ===
Source: libgit2
Section: libs
Priority: optional
Maintainer: Utkarsh Gupta <utkarsh@debian.org>
Uploaders:
 Pirate Praveen <praveen@debian.org>,
 Mohammed Bilal <mdbilal@disroot.org>,
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 ca-certificates,
 cmake,
 debhelper-compat (= 13),
 libkrb5-dev,
 libllhttp-dev [amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x loong64 ppc64],
 libssl-dev,
 libpcre2-dev,
 libssh2-1-dev,
 pkgconf,
 python3-minimal:any,
 zlib1g-dev,
Standards-Version: 4.7.0
Homepage: https://libgit2.github.com/
Vcs-Git: https://salsa.debian.org/debian/libgit2.git
Vcs-Browser: https://salsa.debian.org/debian/libgit2
Rules-Requires-Root: no

Package: libgit2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libgit2-1.8 (= ${binary:Version}),
 libllhttp-dev [amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x loong64 ppc64],
 libssl-dev,
 libpcre2-dev,
 libssh2-1-dev,
 zlib1g-dev,
 ${misc:Depends},
Description: low-level Git library (development files)
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package contains the development files for libgit2.

Package: libgit2-1.8
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: low-level Git library
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.

Package: libgit2-fixtures
Architecture: all
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
Description: low-level Git library - test suite examples
 libgit2 is a portable, pure C implementation of the Git
 distributed version control system core methods provided as a
 re-entrant link-able library with a solid API.
 .
 This package provides the test examples of the library, which
 can be useful for other pieces of software relying on libgit2,
 for testing purposes.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This rules file has 2 streams, the build-debian-devel stream builds
# the static library and the build-debian-release builds the dynamic
# library.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all


ARCH_WITH_LLHTTP = amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x loong64 ppc64

BUILD_TESTS = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
COMMON_CMAKE_FLAGS = \
	-DBUILD_CLI=OFF \
	-DBUILD_TESTS=$(BUILD_TESTS) \
	-DCERT_LOCATION=/etc/ssl/certs/ca-certificates.crt \
	-DDISABLE_ONLINE_TESTS=ON \
	-DENABLE_REPRODUCIBLE_BUILDS=ON \
	-DREGEX_BACKEND=pcre2 \
	-DUSE_GSSAPI=ON \
	-DUSE_HTTPS=OpenSSL \
	-DUSE_NTLMCLIENT=OFF \
	-DUSE_SSH=ON

ifneq (,$(filter $(ARCH_WITH_LLHTTP),$(DEB_HOST_ARCH)))
COMMON_CMAKE_FLAGS += \
	-DUSE_HTTP_PARSER=llhttp
endif

ifeq ($(DEB_HOST_ARCH),ppc64el)
  export DEB_CFLAGS_MAINT_APPEND = -O2
endif

# The stat() in the Git fs layer has some issues
export GITTEST_FLAKY_STAT = true

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-debian-devel -- \
		-DBUILD_SHARED_LIBS=OFF \
		$(COMMON_CMAKE_FLAGS)
	dh_auto_configure --builddirectory=build-debian-release -- \
		-DBUILD_SHARED_LIBS=ON \
		$(COMMON_CMAKE_FLAGS)

override_dh_auto_build:
	dh_auto_build --builddirectory=build-debian-devel
	dh_auto_build --builddirectory=build-debian-release

override_dh_auto_install:
	dh_auto_install --builddirectory=build-debian-devel
	dh_auto_install --builddirectory=build-debian-release

execute_after_dh_auto_install:


override_dh_auto_test:
	dh_auto_test --builddirectory=build-debian-devel
	dh_auto_test --builddirectory=build-debian-release

## libgit2 1.8.4%2Bds

=== fuzzers/CMakeLists.txt ===
# fuzzers: libFuzzer and standalone fuzzing utilities

if(BUILD_FUZZERS AND NOT USE_STANDALONE_FUZZERS)
	set(CMAKE_REQUIRED_FLAGS "-fsanitize=fuzzer-no-link")
	add_c_flag(-fsanitize=fuzzer)
	add_c_flag(-fsanitize=fuzzer-no-link)
	unset(CMAKE_REQUIRED_FLAGS)
endif()

file(GLOB SRC_FUZZERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *_fuzzer.c)
foreach(fuzz_target_src ${SRC_FUZZERS})
	string(REPLACE ".c" "" fuzz_target_name ${fuzz_target_src})
	string(REPLACE "_fuzzer" "" fuzz_name ${fuzz_target_name})

	set(${fuzz_target_name}_SOURCES
		${fuzz_target_src} "fuzzer_utils.c" ${LIBGIT2_OBJECTS})

	if(USE_STANDALONE_FUZZERS)
		list(APPEND ${fuzz_target_name}_SOURCES "standalone_driver.c")
	endif()

	add_executable(${fuzz_target_name} ${${fuzz_target_name}_SOURCES})
	set_target_properties(${fuzz_target_name} PROPERTIES C_STANDARD 90)

	target_include_directories(${fuzz_target_name} PRIVATE ${LIBGIT2_INCLUDES} ${LIBGIT2_DEPENDENCY_INCLUDES})
	target_include_directories(${fuzz_target_name} SYSTEM PRIVATE ${LIBGIT2_SYSTEM_INCLUDES})

	target_link_libraries(${fuzz_target_name} ${LIBGIT2_SYSTEM_LIBS})

	add_test(${fuzz_target_name} "${CMAKE_CURRENT_BINARY_DIR}/${fuzz_target_name}" "${CMAKE_CURRENT_SOURCE_DIR}/corpora/${fuzz_name}")
endforeach()

## libgit2 1.8.4+ds

=== src/libgit2/CMakeLists.txt ===
# libgit2: the shared library: this CMakeLists.txt compiles the core
# git library functionality.

add_library(libgit2 OBJECT)
set_target_properties(libgit2 PROPERTIES C_STANDARD 90)
set_target_properties(libgit2 PROPERTIES C_EXTENSIONS OFF)

include(PkgBuildConfig)

set(LIBGIT2_INCLUDES
	"${PROJECT_BINARY_DIR}/src/util"
	"${PROJECT_BINARY_DIR}/include"
	"${PROJECT_SOURCE_DIR}/src/libgit2"
	"${PROJECT_SOURCE_DIR}/src/util"
	"${PROJECT_SOURCE_DIR}/include")

# Collect sourcefiles
file(GLOB SRC_H
	"${PROJECT_SOURCE_DIR}/include/git2.h"
	"${PROJECT_SOURCE_DIR}/include/git2/*.h"
	"${PROJECT_SOURCE_DIR}/include/git2/sys/*.h")
list(SORT SRC_H)
target_sources(libgit2 PRIVATE ${SRC_H})

file(GLOB SRC_GIT2 *.c *.h
	streams/*.c streams/*.h
	transports/*.c transports/*.h)
list(SORT SRC_GIT2)
target_sources(libgit2 PRIVATE ${SRC_GIT2})

if(WIN32 AND NOT CYGWIN)
	# Add resource information on Windows
	set(SRC_RC "git2.rc")
endif()

if(APPLE)
	# The old Secure Transport API has been deprecated in macOS 10.15.
	set_source_files_properties(streams/stransport.c PROPERTIES COMPILE_FLAGS -Wno-deprecated)
endif()

ide_split_sources(libgit2)
list(APPEND LIBGIT2_OBJECTS $<TARGET_OBJECTS:util> $<TARGET_OBJECTS:libgit2> ${LIBGIT2_DEPENDENCY_OBJECTS})
list(APPEND LIBGIT2_INCLUDES ${LIBGIT2_DEPENDENCY_INCLUDES})

target_include_directories(libgit2 PRIVATE ${LIBGIT2_INCLUDES} ${LIBGIT2_DEPENDENCY_INCLUDES} PUBLIC ${PROJECT_SOURCE_DIR}/include)
target_include_directories(libgit2 SYSTEM PRIVATE ${LIBGIT2_SYSTEM_INCLUDES})

set(LIBGIT2_INCLUDES ${LIBGIT2_INCLUDES} PARENT_SCOPE)
set(LIBGIT2_OBJECTS ${LIBGIT2_OBJECTS} PARENT_SCOPE)
set(LIBGIT2_DEPENDENCY_INCLUDES ${LIBGIT2_DEPENDENCY_INCLUDES} PARENT_SCOPE)
set(LIBGIT2_DEPENDENCY_OBJECTS ${LIBGIT2_DEPENDENCY_OBJECTS} PARENT_SCOPE)
set(LIBGIT2_SYSTEM_INCLUDES ${LIBGIT2_SYSTEM_INCLUDES} PARENT_SCOPE)
set(LIBGIT2_SYSTEM_LIBS ${LIBGIT2_SYSTEM_LIBS} PARENT_SCOPE)

#
# Compile and link libgit2
#

add_library(libgit2package ${SRC_RC} ${LIBGIT2_OBJECTS})
target_link_libraries(libgit2package ${LIBGIT2_SYSTEM_LIBS})
target_include_directories(libgit2package SYSTEM PRIVATE ${LIBGIT2_INCLUDES})

set_target_properties(libgit2package PROPERTIES C_STANDARD 90)
set_target_properties(libgit2package PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_target_properties(libgit2package PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_target_properties(libgit2package PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

ide_split_sources(libgit2package)

if(SONAME)
	set_target_properties(libgit2package PROPERTIES VERSION ${libgit2_VERSION})
	set_target_properties(libgit2package PROPERTIES SOVERSION "${libgit2_VERSION_MAJOR}.${libgit2_VERSION_MINOR}")
	if(LIBGIT2_FILENAME)
		target_compile_definitions(libgit2package PRIVATE LIBGIT2_FILENAME=\"${LIBGIT2_FILENAME}\")
		set_target_properties(libgit2package PROPERTIES OUTPUT_NAME ${LIBGIT2_FILENAME})
	elseif(DEFINED LIBGIT2_PREFIX)
		set_target_properties(libgit2package PROPERTIES PREFIX "${LIBGIT2_PREFIX}")
	endif()
endif()

pkg_build_config(NAME "lib${LIBGIT2_FILENAME}"
	VERSION ${libgit2_VERSION}
	DESCRIPTION "The git library, take 2"
	LIBS_SELF ${LIBGIT2_FILENAME}
	PRIVATE_LIBS ${LIBGIT2_PC_LIBS}
	REQUIRES ${LIBGIT2_PC_REQUIRES})

if(MSVC_IDE)
	# Precompiled headers
	set_target_properties(libgit2package PROPERTIES COMPILE_FLAGS "/Yuprecompiled.h /FIprecompiled.h")
	set_source_files_properties(win32/precompiled.c COMPILE_FLAGS "/Ycprecompiled.h")
endif()

# support experimental features and functionality

configure_file(experimental.h.in "${PROJECT_BINARY_DIR}/include/git2/experimental.h")

# translate filenames in the git2.h so that they match the install directory
# (allows for side-by-side installs of libgit2 and libgit2-experimental.)

FILE(READ "${PROJECT_SOURCE_DIR}/include/git2.h" LIBGIT2_INCLUDE)
STRING(REGEX REPLACE "#include \"git2\/" "#include \"${LIBGIT2_FILENAME}/" LIBGIT2_INCLUDE "${LIBGIT2_INCLUDE}")
FILE(WRITE "${PROJECT_BINARY_DIR}/include/${LIBGIT2_FILENAME}.h" ${LIBGIT2_INCLUDE})

# Install

install(TARGETS libgit2package
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(DIRECTORY ${PROJECT_SOURCE_DIR}/include/git2/
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${LIBGIT2_FILENAME}")
install(FILES ${PROJECT_BINARY_DIR}/include/git2/experimental.h
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${LIBGIT2_FILENAME}")
install(FILES "${PROJECT_BINARY_DIR}/include/${LIBGIT2_FILENAME}.h"
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== debian/changelog ===
libgit2 (1.8.4+ds-3~bpo12+1) bookworm-backports; urgency=medium

  * rebuild on buildds.

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 21 Jan 2025 00:31:55 +0300

libgit2 (1.8.4+ds-3~bpo12+1~bin) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports (needed for rust).
  * Add myself to uploaders.

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 19 Jan 2025 16:57:19 +0300

libgit2 (1.8.4+ds-3) unstable; urgency=medium

  * Use mbedTLS default cipher list for TLS handshake (Closes: #1088281)

 -- Timo Röhling <roehling@debian.org>  Wed, 27 Nov 2024 23:26:26 +0100

libgit2 (1.8.4+ds-2) unstable; urgency=medium

  * Bump cmake_minimum_required() for autopkgtest (Closes: #1087860)

 -- Timo Röhling <roehling@debian.org>  Thu, 21 Nov 2024 11:46:53 +0100

libgit2 (1.8.4+ds-1) unstable; urgency=medium

  * Unvendor llhttp again
  * New upstream version 1.8.4+ds
  * Print the file header on GIT_DIFF_FORMAT_PATCH_HEADER (Closes: #1086494)
  * Move back to http-parser again

 -- Timo Röhling <roehling@debian.org>  Sun, 03 Nov 2024 01:47:58 +0100

=== debian/control ===
--- 
+++ 
@@ -6,13 +6,14 @@
  Pirate Praveen <praveen@debian.org>,
  Mohammed Bilal <mdbilal@disroot.org>,
  Timo Röhling <roehling@debian.org>,
+ Michael Tokarev <mjt@tls.msk.ru>,
 Build-Depends:
  ca-certificates,
  cmake,
  debhelper-compat (= 13),
  libkrb5-dev,
- libllhttp-dev [amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x loong64 ppc64],
- libssl-dev,
+ libhttp-parser-dev,
+ libmbedtls-dev,
  libpcre2-dev,
  libssh2-1-dev,
  pkgconf,
@@ -30,8 +31,8 @@
 Multi-Arch: same
 Depends:
  libgit2-1.8 (= ${binary:Version}),
- libllhttp-dev [amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x loong64 ppc64],
- libssl-dev,
+ libhttp-parser-dev,
+ libmbedtls-dev,
  libpcre2-dev,
  libssh2-1-dev,
  zlib1g-dev,

## libgit2 1.9.0~ds

=== debian/changelog ===
libgit2 (1.9.0~ds-0ubuntu1) plucky; urgency=medium

  * New upstream release.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sat, 04 Jan 2025 22:54:01 -0600

libgit2 (1.8.4+ds-3ubuntu2) plucky; urgency=medium

  [ Zixing Liu ]
  * d/copyright: re-add llhttp for vendoring
  * deps/llhttp: re-vendors llhttp v9.2.1
  * d/rules,control: use vendored llhttp and writes llhttp vendor tag
    (LP: #2080872)

  [ Simon Quigley ]
  * Add use-vendored-llhttp.patch to satisfy dpkg-source.

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 16 Dec 2024 11:50:41 -0700

libgit2 (1.8.4+ds-3ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Use OpenSSL as the crypto backend
    - Use cmake:native in d/tests/control

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Dec 2024 22:35:00 +0100

libgit2 (1.8.4+ds-1ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Use OpenSSL as the crypto backend
    - Use cmake:native in d/tests/control

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 14 Nov 2024 12:59:02 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: libgit2
 Section: libs
 Priority: optional
-Maintainer: Utkarsh Gupta <utkarsh@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Utkarsh Gupta <utkarsh@debian.org>
 Uploaders:
  Pirate Praveen <praveen@debian.org>,
  Mohammed Bilal <mdbilal@disroot.org>,
  Timo Röhling <roehling@debian.org>,
- Michael Tokarev <mjt@tls.msk.ru>,
 Build-Depends:
  ca-certificates,
  cmake,
  debhelper-compat (= 13),
  libkrb5-dev,
  libhttp-parser-dev,
- libmbedtls-dev,
+ libssl-dev,
  libpcre2-dev,
  libssh2-1-dev,
  pkgconf,
@@ -30,9 +30,9 @@
 Section: libdevel
 Multi-Arch: same
 Depends:
- libgit2-1.8 (= ${binary:Version}),
+ libgit2-1.9 (= ${binary:Version}),
  libhttp-parser-dev,
- libmbedtls-dev,
+ libssl-dev,
  libpcre2-dev,
  libssh2-1-dev,
  zlib1g-dev,
@@ -44,7 +44,7 @@
  .
  This package contains the development files for libgit2.
 
-Package: libgit2-1.8
+Package: libgit2-1.9
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -52,6 +52,8 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+Static-Built-Using: ${misc:Static-Built-Using}
+Built-Using: ${misc:Built-Using}
 Description: low-level Git library
  libgit2 is a portable, pure C implementation of the Git
  distributed version control system core methods provided as a

## libgit2 1.9.0%2Bds

=== debian/tests/control ===
Test-Command: cmake debian/tests;make;./libgit2_test
Depends:
 cmake,
 g++,
 gcc,
 @,

## libgit2 1.9.0+ds

=== debian/changelog ===
libgit2 (1.9.0+ds-1ubuntu1) plucky; urgency=medium

  * Merge from Debian Experimental. Remaining changes:
    - Use OpenSSL as the crypto backend
    - Use cmake:native in d/tests/control
    - d/copyright: re-add llhttp for vendoring
    - deps/llhttp: re-vendors llhttp v9.2.1
    - d/rules,control: use vendored llhttp and writes llhttp vendor tag
      (LP: #2080872)
    - Add use-vendored-llhttp.patch to satisfy dpkg-source.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 19 Feb 2025 11:35:09 -0600

libgit2 (1.9.0+ds-1) experimental; urgency=medium

  * New upstream version 1.9.0+ds
    (Closes: #1092215)
  * Drop Debian patch for mbedTLS default cipher list (fixed upstream)
  * Wrap and sort Debian package files
  * Bump SONAME to 1.9
  * Install new CMake config
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Sun, 12 Jan 2025 00:39:53 +0100

=== debian/control ===
--- 
+++ 
@@ -8,11 +8,11 @@
  Mohammed Bilal <mdbilal@disroot.org>,
  Timo Röhling <roehling@debian.org>,
 Build-Depends:
+ debhelper-compat (= 13),
  ca-certificates,
  cmake,
- debhelper-compat (= 13),
+ libhttp-parser-dev,
  libkrb5-dev,
- libhttp-parser-dev,
  libssl-dev,
  libpcre2-dev,
  libssh2-1-dev,

=== debian/rules ===
--- 
+++ 
@@ -8,12 +8,7 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-include /usr/share/dpkg/architecture.mk
-
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
-
-ARCH_WITH_LLHTTP = amd64 arm64 armel armhf mips64el ppc64el riscv64 s390x loong64 ppc64
 
 BUILD_TESTS = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
 COMMON_CMAKE_FLAGS = \
@@ -25,20 +20,15 @@
 	-DREGEX_BACKEND=pcre2 \
 	-DUSE_GSSAPI=ON \
 	-DUSE_HTTPS=OpenSSL \
+	-DUSE_HTTP_PARSER=builtin \
 	-DUSE_NTLMCLIENT=OFF \
 	-DUSE_SSH=ON
 
-ifneq (,$(filter $(ARCH_WITH_LLHTTP),$(DEB_HOST_ARCH)))
-COMMON_CMAKE_FLAGS += \
-	-DUSE_HTTP_PARSER=llhttp
-endif
-
-ifeq ($(DEB_HOST_ARCH),ppc64el)
-  export DEB_CFLAGS_MAINT_APPEND = -O2
-endif
-
 # The stat() in the Git fs layer has some issues
 export GITTEST_FLAKY_STAT = true
+
+# Added by Ubuntu: get vendored llhttp version
+LLHTTP_VERSION := $(shell echo 'LLHTTP_VERSION_MAJOR . LLHTTP_VERSION_MINOR . LLHTTP_VERSION_PATCH' | $(CC) -E -include deps/llhttp/llhttp.h - | tail -n1 | sed 's|\s||g')
 
 %:
 	dh $@ --buildsystem=cmake
@@ -56,11 +46,9 @@
 	dh_auto_build --builddirectory=build-debian-release
 
 override_dh_auto_install:
+	echo 'misc:Static-Built-Using=llhttp (= $(LLHTTP_VERSION))' >> debian/libgit2-1.8.substvars
 	dh_auto_install --builddirectory=build-debian-devel
 	dh_auto_install --builddirectory=build-debian-release
-
-execute_after_dh_auto_install:
-
 
 override_dh_auto_test:
 	dh_auto_test --builddirectory=build-debian-devel

## libgit2 1.9.1%2Bds

=== src/cli/CMakeLists.txt ===
set(CLI_INCLUDES
	"${libgit2_BINARY_DIR}/src/util"
	"${libgit2_BINARY_DIR}/include"
	"${libgit2_SOURCE_DIR}/src/util"
	"${libgit2_SOURCE_DIR}/src/cli"
	"${libgit2_SOURCE_DIR}/include"
	"${LIBGIT2_DEPENDENCY_INCLUDES}"
	"${LIBGIT2_SYSTEM_INCLUDES}")

if(WIN32 AND NOT CYGWIN)
	file(GLOB CLI_SRC_OS win32/*.c)
	list(SORT CLI_SRC_OS)
else()
	file(GLOB CLI_SRC_OS unix/*.c)
	list(SORT CLI_SRC_OS)
endif()

file(GLOB CLI_SRC_C *.c *.h)
list(SORT CLI_SRC_C)

#
# The CLI currently needs to be statically linked against libgit2 because
# the utility library uses libgit2's thread-local error buffers.  TODO:
# remove this dependency and allow us to dynamically link against libgit2.
#

if(BUILD_CLI STREQUAL "dynamic")
	set(CLI_LIBGIT2_LIBRARY libgit2package)
else()
	set(CLI_LIBGIT2_OBJECTS $<TARGET_OBJECTS:libgit2>)
endif()

#
# Compile and link the CLI
#

add_executable(git2_cli ${CLI_SRC_C} ${CLI_SRC_OS} ${CLI_OBJECTS}
	$<TARGET_OBJECTS:util>
	${CLI_LIBGIT2_OBJECTS}
	${LIBGIT2_DEPENDENCY_OBJECTS})
target_link_libraries(git2_cli ${CLI_LIBGIT2_LIBRARY} ${LIBGIT2_SYSTEM_LIBS})

set_target_properties(git2_cli PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${libgit2_BINARY_DIR})
set_target_properties(git2_cli PROPERTIES OUTPUT_NAME ${LIBGIT2_FILENAME})

ide_split_sources(git2_cli)

target_include_directories(git2_cli PRIVATE ${CLI_INCLUDES})

if(MSVC_IDE)
	# Precompiled headers
	set_target_properties(git2_cli PROPERTIES COMPILE_FLAGS "/Yuprecompiled.h /FIprecompiled.h")
	set_source_files_properties(win32/precompiled.c COMPILE_FLAGS "/Ycprecompiled.h")
endif()

install(TARGETS git2_cli RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
